PlayerDialogSegmentGroupDataWrapper = PlayerDialogSegmentGroupDataWrapper or blt_class(CellDataBaseWrapper)

function PlayerDialogSegmentGroupDataWrapper:setup()
	self:base_setup()	
	
	self:add_descriptor("ActorA, ActorB, ActorC, ActorD", DataDescriptor:new({
		dataLayoutType = DataDescriptor.DataLayoutType.Default,
		headerText = "ACTOR CONDITIONS",
		hasHeader = true,
		comment = "The conditions and what characters are allowed",
	}), false)	
	
	
	self:add_descriptor("segments", DataDescriptor:new({
		dataLayoutType = DataDescriptor.DataLayoutType.BulkyList,
		headerText = "Dialogue Segments",
		hasHeader = true,
		comment = "Edit the lines of the heisters to say in order",
	}), false)	
	
	self:add_descriptor("SwitchDialogChance", DataDescriptor:new({
		dataLayoutType = DataDescriptor.DataLayoutType.Slider,
		headerText = "CHANCE TO TRIGGER NEXT DIALOGUE",
		hasHeader = true,
		MinMax = {
			min = 0,
			max = 1
		},
		comment = "If \"SwitchDialogID\" is greater than zero or it is valid then this amount chance will likely trigger this dialogue (range 0-1)",
	}), false)	
	
	self:add_descriptor("SwitchDialogID", DataDescriptor:new({
		dataLayoutType = DataDescriptor.DataLayoutType.BlockIDSelector,
		headerText = "DIALOGUE TO TRIGGER AFTER DONE",
		hasHeader = true,
		dataBlockType = "PlayerDialogDataBlock",
		comment = "This dialogue will trigger when the current dialogue finishes based on the chance of \"SwitchDialogChance\".",
	}), false)	
	
	self:add_descriptor("alert, assault, control, sneaking", DataDescriptor:new({
		dataLayoutType = DataDescriptor.DataLayoutType.CheckBox,
		headerText = "DRAMA STATE FILTER",
		hasHeader = true,
		comment = "If enabled, the dialogue can only be played if the current DramaState is allowed",
	}), false)	
	
end
