DramaStateFakeAssault = DramaStateFakeAssault or blt_class(DramaStateBase)

function DramaStateFakeAssault:setup()
	self._time_before_going_down = 30
end


function DramaStateFakeAssault:enter(exit_data)
	self._machine:trigger_line("p47")	
	self:set_wave_flag(true)
	managers.cell_music:change_state(MusicMachine.MUS_States.Assault)
	self._player_last_combat_chatter_t = nil
end

function DramaStateFakeAssault:common_update(t, dt)

	if self._drama_manager:go_to_assault() then
		self._machine:change_drama_state(DramaMachine.STATES.Assault, true)
		return
	end	
	
	if t - self._machine:state_enter_t() > self._time_before_going_down then		
		if self._drama_manager:go_to_control() then
			self._machine:change_drama_state(DramaMachine.STATES.Alert, true)
			return
		end		
	end
	
		
end

function DramaStateFakeAssault:update(t,dt)
	self:common_update(t,dt)
end

function DramaStateFakeAssault:sync_update(t,dt)
	self:common_update(t,dt)
end


function DramaStateFakeAssault:idle_dialog()
	managers.player_dialog:queue_dialog(27, {})
end

function DramaStateFakeAssault:debug_prefix()
	return "DramaStateFakeAssault"
end
