dofile(ModPath.. "Lua/Scripts/Interactions/CellBaseInteraction.lua")
dofile(ModPath.. "Lua/Scripts/Interactions/CellIntimidateInteraction.lua")
dofile(ModPath.. "Lua/Scripts/Interactions/CellReviveInteraction.lua")
dofile(ModPath.. "Lua/Scripts/Interactions/CellConvertHostageInteraction.lua")

CellInteractionManager = CellInteractionManager or blt_class()
CellInteractionManager.DEBUG_ENABLED = false

function CellInteractionManager:init()
	self._interactions = {}
	self._interactions.intimidate = CellIntimidateInteraction:new()
	self._interactions.revive = CellReviveInteraction:new()
	self._interactions.hostage_convert = CellConvertHostageInteraction:new()
end

function CellInteractionManager:debug_print(txt)
	if CellInteractionManager.DEBUG_ENABLED then
		log("CellInteractionManager - " .. txt)
	end
end

function CellInteractionManager:interaction_complete(interactor, object, tweak_data, t)
	
	
	self:debug_print("interaction completed tweak data : " .. tostring(tweak_data))
	
	if not tweak_data then
		return
	end
	
	if self._interactions[tweak_data] then
		self._interactions[tweak_data]:interaction_complete(interactor, object, t)
	end
end

function CellInteractionManager:interaction_interrupted(interactor, object, tweak_data, t)
	
	
	self:debug_print("interaction interrupted tweak data : " .. tostring(tweak_data))
	
	if not tweak_data then
		return
	end
	
	if self._interactions[tweak_data] then
		self._interactions[tweak_data]:interaction_interrupted(interactor, object, t)
	end
end

function CellInteractionManager:interaction_start(interactor, object, tweak_data, t)
	
	
	self:debug_print("interaction started tweak data : " .. tostring(tweak_data))
	
	if not tweak_data then
		return
	end
	
	if self._interactions[tweak_data] then
		self._interactions[tweak_data]:interaction_start(interactor, object, t)
	end
end