DrillManager = DrillManager or blt_class()

function DrillManager:init()
	self._jammed_drills = {}
end

function DrillManager:get_drill_name(unit)
	local tweak_data = unit and unit.interaction and unit:interaction() and unit:interaction().tweak_data
	local drill_name = tweak_data and tweak_data:gsub('_jammed',''):gsub('_upgrade','')
	return drill_name
end

function DrillManager:amount_of_saws()
	local amount = 0
	for d_key, d_data in pairs(self:all_active_drills()) do
		if d_data.is_saw then
			amount = amount + 1
		end
	end
	return amount
end

function DrillManager:register_jammed_drill(unit)
	if not unit then
		return
	end
	local u_key = unit:key()
	local u_sighting = {
		unit = unit,
		pos = unit:position(),
		priority = 6
	}
	if unit.base and unit:base() then
		if unit:base().is_huge_lance then
			u_sighting.priority = 1
		elseif self:get_drill_name(unit) == "lance" then
			u_sighting.priority = 2
		elseif unit:base().is_hacking_device then
			u_sighting.priority = 3
		elseif unit:base().is_saw then
			u_sighting.priority = 4
		elseif unit:base().is_drill then
			u_sighting.priority = 5
		end
		u_sighting.jammed_count = unit:base()._jammed_count
	end
	self._jammed_drills[u_key] = u_sighting
	if next(self._jammed_drills) and not self._drill_remind_clbk then
		self._next_jammed_reminder_t = 30
		self._drill_remind_id = "CellDrillJammed"
		self._drill_remind_clbk = callback(self, self, "_drill_reminder_clbk")
		managers.cell_callback:add_delayed_callback(self._drill_remind_id, 20, self._drill_remind_clbk)
	end
end

function DrillManager:unregister_jammed_drill(unit)
	if not unit then
		return
	end
	self._jammed_drills[unit:key()] = nil
	if not next(self._jammed_drills) and self._drill_remind_clbk then
		managers.cell_callback:remove_delayed_clbk(self._drill_remind_id)
		self._drill_remind_clbk = nil
	end
end

function DrillManager:closest_jammed_drill()
	local close_u_data_d, best_priority, close_u_data
	local close_pos = managers.player:player_unit() and managers.player:player_unit():position() or Vector3()
	for u_key, u_data in pairs(self._jammed_drills) do
		local close_dis = mvector3.distance_sq(close_pos, u_data.pos)
		if (not close_u_data_d or close_dis < close_u_data_d) and (not best_priority or u_data.priority <= best_priority) then
			close_u_data_d = close_dis
			close_u_data = u_data
			best_priority = u_data.priority
		end
	end
	return close_u_data
end

DrillManager.REMMINDER_COMMENTS_IDS = {}
DrillManager.REMMINDER_COMMENTS_IDS.Drill = 1
DrillManager.REMMINDER_COMMENTS_IDS.Hacking_Device = 2
DrillManager.REMMINDER_COMMENTS_IDS.Saw = 3
DrillManager.REMMINDER_COMMENTS_IDS.Thermal_Lance = 4
DrillManager.REMMINDER_COMMENTS_IDS.Default = 5

function DrillManager:drill_remminder_comment(d_data)
	
end

function DrillManager:_drill_reminder_clbk()

	local d_data = self:closest_jammed_drill()
	if d_data then
	
	end
	
	managers.cell_callback:add_delayed_callback(self._drill_remind_id, self._next_jammed_reminder_t, self._drill_remind_clbk)
	
	
	if self._next_jammed_reminder_t >= 75 then
		return
	end
	self._next_jammed_reminder_t = self._next_jammed_reminder_t + 15
end

function DrillManager:all_jammed_drills()
	return self._jammed_drills
end