DeadLockeMainManager = DeadLockeMainManager or blt_class()

function DeadLockeMainManager:get_maximum_downs_until_death(unit)
	local u_key = unit:key()
	local last_down = 3
	local additional_lives
	if unit:base().is_local_player then
		additional_lives = managers.player:has_category_upgrade("player", "additional_lives") and true or false
	end
	if additional_lives then
		last_down = last_down + 1
	end
	if Global.game_settings.one_down then
		last_down = last_down - 2
	end
	return last_down
end

function DeadLockeMainManager:player_unit()
	return managers.player:player_unit()
end
function DeadLockeMainManager:is_unit_player(unit)
	return managers.groupai:state():all_player_criminals()[unit:key()] and true or false
end
function DeadLockeMainManager:is_unit_char_criminal(unit)
	return managers.groupai:state():all_char_criminals()[unit:key()] and true or false
end
function DeadLockeMainManager:is_unit_team_AI(unit)
	return managers.groupai:state():is_unit_team_AI(unit)
end

function DeadLockeMainManager:display_notification()
	do return end
	
	local title_text = "PROJECT: DeadLocke Up-to-Date!"
	local message_text = "PROJECT: DeadLocke is ready for use."
	if DeadLockeMainManager.update_required then
		title_text = "PROJECT: DeadLocke Update-Acquired!"
		message_text = "PROJECT: DeadLocke has an update waiting to be installed!"
	end
	
	local id = "deadlocke_updates_desynchronised"
	local title = title_text
	local message = message_text
	local priority = 100
	
	if not NotificationsManager:NotificationExists( id ) then
		NotificationsManager:AddNotification( id, title, message, priority )
	else
		NotificationsManager:UpdateNotification( id, title, message, priority + 1 )
	end
end


function DeadLockeMainManager:display_new_user()
	local block = managers.deadlockegameblock:wrapper("IntroDataBlock"):get_block_by_id(self._Block.updateLogsBlockID)
	if block and (block.Forced or not self._data[block.value]) then		
		self._data[block.value] = true
		if self:isNotNilorEmpty(block.SoundEvent) then
			managers.menu_component:post_event(block.SoundEvent, true)
		end
		local function go_to_the_mod_options()
			managers.menu:open_node("options")
			managers.menu:open_node("blt_options")
			managers.menu:open_node("can_menu_id")			
		end
		local menu_options = {
			[1] = {
				text = managers.localization:text("can_ban_news_checkitout_btn"),
				callback = go_to_the_mod_options
			},
			[2] = {
				text = managers.localization:text("can_ban_news_exit_btn"),
				is_cancel_button = true,
			}
		}
		local IntroTitle = block.IntroTitle
		local IntroDesc = block.IntroDesc
		if block.Localized then
			IntroTitle = managers.localization:text(block.IntroTitle)
			IntroDesc = managers.localization:text(block.IntroDesc)
		end
		local username = tostring(managers.network.account:username() or managers.blackmarket:get_preferred_character_real_name())	
		QuickMenu:new(IntroTitle, IntroDesc, menu_options, true)
		self:Save()
	end
end