Chatter = Chatter or blt_class()
Chatter._path = ModPath
Chatter._user_data_path = SavePath .. "Chatter.txt"
Chatter._user_data = {}

function Chatter:init()
	self:LoadUserSettings()	
	self._delayed_callbacks = {}
	self._t = 0
	self._dt = 0
end

function Chatter:update(t, dt)
	self._t = t
	for i, clbk_data in pairs(self._delayed_callbacks) do	
		if clbk_data and clbk_data.goaltimer < t then
			clbk_data.clbk()
			table.remove(self._delayed_callbacks, i)
		end
	end
end

function Chatter:remove_delayed_clbk(id)	
	for i, clbk_data in pairs(self._delayed_callbacks) do	
		if clbk_data and clbk_data.id == id then
			table.remove(self._delayed_callbacks, i)
			return
		end
	end
end

function Chatter:add_delayed_callback(id, goaltimer, clbk)
	self:remove_delayed_clbk(id)
	
	local clbk_data = {
		id = id,
		goaltimer = self._t + goaltimer,
		clbk = clbk
	}
	
	table.insert(self._delayed_callbacks, clbk_data)
end


function Chatter:SaveUserSettings()
	local file = io.open( self._user_data_path, "w+" )
	if file then
		local json_string = json.encode( self._user_data )		
		file:write(json_string)
		file:close()
	end
end


function Chatter:LoadUserSettings()
	local file = io.open( self._user_data_path, "r" )
	if file then	
		local json_string = file:read("*all")
		self._user_data = JsonUtils:safe_decode(json_string or {})		
		file:close()		
	end
end