CellNetValidationAction = CellNetValidationAction or blt_class()
CellNetValidationAction.DEBUG_ENABLED = true


function CellNetValidationAction:debug_print(txt)
	if CellNetValidationAction.DEBUG_ENABLED then
		log("CellNetValidationAction - " .. txt)
	end	
end

function CellNetValidationAction:init(packet_id, action_clbk)
	self._action_callback = action_clbk
	self._packet_id = packet_id
	self._enabled = true
	managers.cell_network:register_action_validation(self)
	self:debug_print("Registering a packet validator : " ..self._packet_id)
end

function CellNetValidationAction:network_id()
	return managers.cell_network:network_id()
end

function CellNetValidationAction:destroy()
	self._enabled = false
end

function CellNetValidationAction:enabled()
	return self._enabled
end

function CellNetValidationAction:packet_id()
	return self._packet_id
end

function CellNetValidationAction:Do(data, sender)
	self._action_callback(data, sender)
end

function CellNetValidationAction:create_a_packet(data)
	return JsonUtils:safe_encode({
		self._packet_id,
		data
	})
end

function CellNetValidationAction:send_to_peers(data)	
	LuaNetworking:SendToPeers(self:network_id(), self:create_a_packet(data))
end

function CellNetValidationAction:send_to_peers_except(peer_id, data)
	LuaNetworking:SendToPeersExcept(peer_id, self:network_id(), self:create_a_packet(data))
end

function CellNetValidationAction:send_to_peer(peer_id, data)
	LuaNetworking:SendToPeer(peer_id, self:network_id(), self:create_a_packet(data))
end

function CellNetValidationAction:send_to_cell_host(data)
	LuaNetworking:SendToPeer(managers.cell_user:cell_host_peer_id(), self:network_id(), self:create_a_packet(data))
end