DeadLockeInteractionMarking = DeadLockeInteractionMarking or class(DeadLockeInteractionStandard)
DeadLockeInteractionMarking._id = "PlayerStandard:_start_action_intimidate"
DeadLockeInteractionMarking.VARIANTS = {
	mark_tank = {
		requirements = {},
		modify_chance = "ply_spot_dozer_chance",
		distance = 800,
		chance = 0.5,
		comment = "g29",
		characters_can = {
			american = true,
			russian = true,
			german = true,
			spanish = true,
			old_hoxton = true,
			jowi = true,
			wild = true,
			sydney = true,
			jimmy = true,
			female_01 = true,
			sokol = true,
		}
	},
	mark_tank_hw = {
		requirements = {},
		modify_chance = "ply_spot_dozer_chance",
		distance = 1000,
		chance = 0.75,
		comment = "g29",
		characters_can = {
			american = true,
			russian = true,
			german = true,
			spanish = true,
			old_hoxton = true,
			jowi = true,
			wild = true,
			sydney = true,
			jimmy = true,
			female_01 = true,
			sokol = true,
		}
	},
	mark_tank_mini = {
		requirements = {},
		modify_chance = "ply_spot_dozer_chance",
		distance = 1000,
		chance = 0.75,
		comment = "g29",
		characters_can = {
			american = true,
			russian = true,
			german = true,
			spanish = true,
			old_hoxton = true,
			jowi = true,
			wild = true,
			sydney = true,
			jimmy = true,
			female_01 = true,
			sokol = true,
		}
	},
	mark_tank_medic = {
		requirements = {},
		modify_chance = "ply_spot_dozer_chance",
		distance = 1000,
		chance = 0.75,
		comment = "g29",
		characters_can = {
			american = true,
			russian = true,
			german = true,
			spanish = true,
			old_hoxton = true,
			jowi = true,
			wild = true,
			sydney = true,
			jimmy = true,
			female_01 = true,
			sokol = true,
		}
	}
}

function DeadLockeInteractionMarking:modify_value(id, sound_name, voice_type, target_unit, ...)
	if self._id == id then
		if DeadLockeInteractionMarking.VARIANTS[voice_type] then
			voice_type_data = DeadLockeInteractionMarking.VARIANTS[voice_type]
			if voice_type_data.requirements then
				if not DeadLocke:has_requirements(voice_type_data.requirements) then
					return nil
				end
			end
			local character = managers.criminals:local_character_name()
			local player = managers.player:player_unit()
			local distance = 0
			if target_unit then
				local target_head_pos = target_unit:movement():m_head_pos() + math.UP * 30
				local vec = target_head_pos - player:movement():m_pos()
				distance = mvector3.normalize(vec)
			end
			local chance = voice_type_data.chance or 0
			if voice_type_data.modify_chance then
				chance = 0
				local value = DeadLocke:get_value(voice_type_data.modify_chance)
				if value then
					chance = value / 100
				end
			end
			if chance == 0 then
				return nil
			end
			if voice_type_data.characters_can and voice_type_data.characters_can[character] and distance < voice_type_data.distance then
				if chance >= math.random() then
					return voice_type_data.comment
				end
			end
		end
	end
	return nil
end