DeadLockeInteractionStandard = DeadLockeInteractionStandard or class()
DeadLockeInteractionStandard._id = "PlayerStandard:_start_action_intimidate"
DeadLockeInteractionStandard.VARIANTS = {
	revive = {
		requirements = {"ply_inspire_toggle"},
		characters = {
			american = {"g13","f41_any"},
			spanish = {"g13","f36x_any"},
			german = {"f41_any"},
			russian = {"g13","f36x_any"}
		}
	},
	escort_keep = {
		characters = {
			russian = {"p12","g09","f40_any"},
			german = {"p12","g09","f40_any"},
			spanish = {"g09","f40_any"}
		}
	},
	escort_go = {
		characters = {
			russian = {"p16","p14","p13","p15",},
			german = {"p16","p18","p15","g18"},	
			old_hoxton = {"p15","p14","p16"}
		}
	},
	escort_get_up = {
		characters = {
			russian = {"f41_any","f40_any"},
			german = {"f41_any","p15"},	
			old_hoxton = {"f41_any","p15"}
		}
	},
	mark_turret = {
		requirements = {"ply_turret_mark_toggle"},
		characters = {
			russian = {"f42_any","f44x_any"},
			german = {"g10","f44x_any"},	
			old_hoxton = {"g29","f42_any","g10","f44x_any"},
			spanish = {"g29","f42_any","g10","f44x_any"}
		}
	},
	mark_cop_quiet = {
		requirements = {"ply_spot_toggle"},
		characters = {
			russian = {'g10','g15',"{sound}"},
			american = {'g10','g15',"{sound}"},
			sokol = {'g10','g15',"{sound}"},
			jowi = {'g10','g15',"{sound}"},
			dragan = {'g10','g15',"{sound}"},
		}
	}
}


function DeadLockeInteractionStandard:modify_value(id, sound_name, voice_type, ...)
	if self._id == id then
		if DeadLockeInteractionStandard.VARIANTS[voice_type] then
			local vr_character = managers.criminals:local_character_name()
			local voice_type_variant = DeadLockeInteractionStandard.VARIANTS[voice_type]
			if voice_type_variant.requirements then
				if not DeadLocke:has_requirements(voice_type_variant.requirements) then
					return nil
				end
			end
			if voice_type_variant and voice_type_variant.characters and voice_type_variant.characters[vr_character] then
				local voices_table = voice_type_variant.characters[vr_character]
				if voices_table and type(voices_table) == "table" then
					local random_sound_name = voices_table[math.random(#voices_table)]
					if random_sound_name ~= "{sound}" then
						return random_sound_name
					end
				end
			end
		end
	end
	return nil
end