DeadLockeInteractionWeight = DeadLockeInteractionWeight or class(DeadLockeInteractionStandard)
DeadLockeInteractionWeight._id = "PlayerStandard:_start_action_intimidate"
DeadLockeInteractionWeight.VARIANTS = {
	mark_camera = {
		requirements = {"ply_cams_toggle"},
		characters = {
			spanish = {
				{
					value = "g25",
					weight = 1
				},
				{
					value = "f39_any",
					weight = 4
				}
			}
		}
	},
	mark_sniper = {
		requirements = {"ply_spot_sniper_toggle"},
		characters = {
			german = {
				{
					value = "g15",
					weight = 1
				},
				{
					value = "f42_any",
					weight = 2
				},
				{
					value = "{sound}",
					weight = 4
				}
			}
		}
	},
	mark_medic = {
		requirements = {"ply_spot_medic_toggle"},
		characters = {
			russian = {
				{
					value = "g23",
					weight = 1
				},
				{
					value = "{sound}",
					weight = 3
				}
			},
			old_hoxton = {
				{
					value = "g10",
					weight = 1
				},
				{
					value = "g23",
					weight = 2
				},
				{
					value = "{sound}",
					weight = 5
				}
			},
			spanish = {
				{
					value = "g10",
					weight = 1
				},
				{
					value = "{sound}",
					weight = 3
				}
			},
			german = {
				{
					value = "f42_any",
					weight = 2
				},
				{
					value = "g10",
					weight = 2
				},
				{
					value = "g23",
					weight = 3
				},
				{
					value = "{sound}",
					weight = 6
				}
			},
			american = {
				{
					value = "g10",
					weight = 2
				},
				{
					value = "g23",
					weight = 3
				},
				{
					value = "{sound}",
					weight = 6
				}
			}
		}
	},
	boost = {
		characters = {
			russian = {
				{
					value = "g18",
					weight = 1
				},
				{
					value = "f40_any",
					weight = 3
				},
				{
					value = "g09",
					weight = 2
				},
			},
			american = {
				{
					value = "g18",
					weight = 1
				},
				{
					value = "g09",
					weight = 3
				}
			},
			spanish = {
				{
					value = "g09",
					weight = 1
				},
				{
					value = "g18",
					weight = 2
				}
			},
			german = {
				{
					value = "g09",
					weight = 2
				},
				{
					value = "f40_any",
					weight = 3
				},
				{
					value = "g18",
					weight = 0.5
				}
			},
			jowi = {
				{
					value = "f40_any",
					weight = 1
				},
				{
					value = "g09",
					weight = 1
				}
			},
			old_hoxton = {
				{
					value = "g09",
					weight = 1
				},
				{
					value = "f40_any",
					weight = 2
				},
				{
					value = "g18",
					weight = 4
				}
			},
			bodhi = {
				{
					value = "f40_any",
					weight = 2
				},
				{
					value = "g09",
					weight = 2
				},
				{
					value = "g18",
					weight = 4
				},
			},
			chico = {
				{
					value = "f40_any",
					weight = 2
				},
				{
					value = "g09",
					weight = 2
				},
				{
					value = "g18",
					weight = 4
				},
			},
			jimmy = {
				{
					value = "f40_any",
					weight = 2
				},
				{
					value = "g09",
					weight = 2
				},
				{
					value = "g18",
					weight = 4
				},
			}
		}
	}
}


local DLC_CHARACTERS = {
	{
		value = "g18",
		weight = 1,
	},
	{
		value = "g09",
		weight = 1,
	}
}

DeadLockeInteractionWeight.VARIANTS.mark_camera.sokol = DeadLockeInteractionWeight.VARIANTS.mark_camera.spanish


DeadLockeInteractionWeight.VARIANTS.boost.max = DLC_CHARACTERS
DeadLockeInteractionWeight.VARIANTS.boost.wild = DLC_CHARACTERS
DeadLockeInteractionWeight.VARIANTS.boost.jacket = DLC_CHARACTERS
DeadLockeInteractionWeight.VARIANTS.boost.female_1 = DLC_CHARACTERS
DeadLockeInteractionWeight.VARIANTS.boost.ecp_male = DLC_CHARACTERS
DeadLockeInteractionWeight.VARIANTS.boost.ecp_female = DLC_CHARACTERS
DeadLockeInteractionWeight.VARIANTS.boost.myh = DLC_CHARACTERS
DeadLockeInteractionWeight.VARIANTS.boost.sydney = DLC_CHARACTERS
DeadLockeInteractionWeight.VARIANTS.boost.sokol = DLC_CHARACTERS 

function DeadLockeInteractionWeight:modify_value(id, value_name, voice_type, ...)
	if self._id == id then
		if DeadLockeInteractionWeight.VARIANTS[voice_type] then
			local vr_character = managers.criminals:local_character_name()
			local voice_type_variant = DeadLockeInteractionWeight.VARIANTS[voice_type]
			if voice_type_variant.requirements then
				if not DeadLocke:has_requirements(voice_type_variant.requirements) then
					return nil
				end
			end
			if voice_type_variant.characters and voice_type_variant.characters[vr_character] then
				local boosting_lines = voice_type_variant.characters[vr_character] 
				if boosting_lines and next(boosting_lines) then
					local sound = DeadLocke:choose_best_weight(boosting_lines)
					if sound ~= "{value}" then
						return sound
					end
				end
			end
		end
	end
	return nil
end