DeadLockeTeammatesManager = DeadLockeTeammatesManager or blt_class()

function DeadLockeTeammatesManager:can_criminal_say(sound_name, unit)
	local block = managers.deadlockegameblock:wrapper("CriminalsSayFiltersDataBlock"):get_block_by_id(1)
	if block then
		local char_name = managers.criminals:character_name_by_unit(unit)
		if block.filters[sound_name] then
			local sound_name_data = block.filters[sound_name]
			if sound_name_data.canners then
				return table.contains(sound_name_data.characters, char_name)
			else
				return not table.contains(sound_name_data.characters, char_name)
			end
		end
	end
	return true
end


function DeadLockeTeammatesManager:criminal_comment(trigger_unit, allow_first_person, message, pos, pos_based, radius, sync)
	if not managers or not managers.groupai or not managers.groupai.state then
		return
	end
	if not message then
		return
	end

	local cam_position = self:get_cam_position()
			
	local close_unit, close_unit_d, trigger_unit_name
	if radius and type(radius) == "string" then
		radius = tonumber(radius) or nil
	end
	if pos and type(pos) == "string" then
		if pos == "nil" then
			pos = nil
		else
			pos = self:String_to_Vector(pos)
		end
	end
	
	if trigger_unit and type(trigger_unit) == "string" then
		trigger_unit = managers.criminals:character_unit_by_name(trigger_unit)	
	end
	
	if radius and radius <= 0 then
		radius = nil
	end
	
	local function can_say(unit)
		self:can_criminal_say(message, unit)
	end
	
	
	local function is_speaking(ext_sound)
		return ext_sound:speaking()
	end
	
	local close_pos = pos_based and pos or managers.player:player_unit() and managers.player:player_unit():position() or cam_position
	
	if trigger_unit and alive(trigger_unit) then
		if can_say(trigger_unit) then
			close_unit = trigger_unit
			trigger_unit_name = managers.criminals:character_name_by_unit(trigger_unit)
			if not trigger_unit_name then
				self:debug_log("[DeadLocke:criminal_comment] trigger_unit_name is not valid!!")
				return
			end
			radius = nil
		end
	else
		for u_key, u_data in pairs(managers.groupai:state():all_char_criminals()) do
			if u_data and not u_data.is_deployable and u_data.unit and alive(u_data.unit) and (allow_first_person or not u_data.unit:base().is_local_player) and not u_data.unit:movement():downed() and not is_speaking(u_data.unit:sound()) then
				if can_say(u_data.unit) then
					local close_dis = mvector3.distance_sq(close_pos, u_data.m_pos)
					if (not radius or close_dis < radius * radius) and (not close_unit_d or close_dis < close_unit_d) then
						close_unit = u_data.unit
						close_unit_d = close_dis
					end
				end
			end
		end
	end
	
	if close_unit then
		close_unit:sound():say(message, false, true)
	end
	
	if sync then
		--DeadLockeNetwork:send_json_data_to_peers("sync_criminal_comment", trigger_unit_name, allow_first_person, message, pos and tostring(pos), pos_based, radius or 0)
	end
	
end