BinaryEncoder = BinaryEncoder or blt_class()

function BinaryEncoder:Encode(coder, text)

	local bytes = ByteTools:GetBytes(text)

	local codes = coder.codes
	local size = coder.size
	local Length = #bytes

	for i = 0, Length do
		local randomIndex = i + codes[math.fmod(i,size)]
		if randomIndex > Length then
			randomIndex = Length
		end

		local b = bytes[randomIndex]
		bytes[randomIndex] = bytes[i]
		bytes[i] = b
	end

	return bytes
end

function BinaryEncoder:HashCode(bytes)
	local hash = ""	
	for index, bit in pairs(bytes) do
		hash = hash .. tostring(bit)
	end
	return hash
end

function BinaryEncoder:Decode(coder, bytes)
	local codes = coder.codes
	local size = coder.size
	local Length = #bytes

	for i = Length, 0, -1 do
		local randomIndex = i + codes[math.fmod(i,size)]
		if randomIndex > Length then
			randomIndex = Length
		end

		local b = bytes[randomIndex]
		bytes[randomIndex] = bytes[i]
		bytes[i] = b
	end

	return ByteTools:GetString(bytes)
end

function BinaryEncoder:WriteBytes(filePath, bytes)
	local str = ByteTools:GetString(bytes)
	FileUtils:WriteAllText(filePath, str)
end


BP_Coder = BP_Coder or blt_class()

function BP_Coder:init(key)
	math.randomseed(key)
	self.size = math.random(50, 70);
	self.codes = {}
	local _min = 2
	local _max = math.random(47, 50);
	for i = 0, self.size do
		self.codes[i] = math.random(_min, _max);
	end
	math.randomseed(os.clock())
end