SerializableObject = SerializableObject or blt_class()
SerializableObject._current_order = 0
SerializableObject._fields = 0

function SerializableObject:apply_class(field_name, class_name)
	if self and self[field_name] then
		self[field_name] = rawget(_G, class_name):load(self[field_name])
	end
end

function SerializableObject:apply_class_to_array(field_name, class_name)
	if self[field_name] == nil then
		self[field_name] = {}			
	end	
	
	if self[field_name] and next(self[field_name]) then
		for i, v in pairs(self[field_name])  do
			self[field_name][i] = rawget(_G, class_name):load(v)
		end	
	end
end

function SerializableObject:register_field(class_name, field_name, value_type, final)
	if not self._current_order then
		self._current_order = 0
	end
	self._current_order = self._current_order + 1
	self._fields[self._current_order] = {}
	
	self._fields[self._current_order].write_callback = function(writer)
		if final then
			writer:WriteFinal(field_name, value_type)	
		else
			writer:Write(field_name, value_type)
		end				
	end
	
	self._fields[self._current_order].load_callback = function()
		if class_name then
			self:apply_class_to_array(field_name, class_name)	
		end
	end
	
	self._fields[self._current_order].new_callback = function(...)
		if value_type == "string" then
			self[field_name] = ""
		elseif value_type == "number" then
			self[field_name] = 0
		end
	end
	
end

function SerializableObject:load_additional(data)

end

function SerializableObject:load(data)
	local object = {}
	setmetatable(object, self)
	copy_values_to_object(object, data)
	object:load_additional(data)
	return object
end
	

function SerializableObject:SerializeFields(writer)
end


function SerializableObject:Serialize(indent, ignore_first_indent)
	local writer = JsonWriter:new(self, indent)	
	self:SerializeFields(writer)
	return writer:Results()
end