SerializableObject = SerializableObject or blt_class()

function SerializableObject:object_callback(clbk_name, o,...)
	if self._current_order and self._current_order > 0 then
		for i = self._current_order, 1, -1 do
			self._fields[i][clbk_name](o,...)
		end
	end
end

function SerializableObject:LoadCallback(o, ...)
	if self._current_order and self._current_order > 0 then
		for i = self._current_order, 1, -1 do
			self._fields[i].load_callback(o, ...)
		end
	end
end

function SerializableObject:init(...)
	self:object_callback("new_callback",self,...)
end


function SerializableObject:apply_class(field_name, class_name)
	local class = rawget(_G, class_name)
	if class then
		if self[field_name] then
			self[field_name] = class:load(self[field_name])
			print("Load class!!")
		else
			print("field_name doesn't exist!! : " .. field_name)
		end
	else
		print("class doesn't exist!! : " .. class_name)
	end
end

function SerializableObject:apply_class_to_array(field_name, class_name)
	if self[field_name] == nil then
		self[field_name] = {}
	end

	if self[field_name] and next(self[field_name]) then
		for i, v in pairs(self[field_name])  do
			self[field_name][i] = rawget(_G, class_name):load(v)
		end
	end
end

function copy_values_to_object(to_object, from_object)
	if from_object and next(from_object) then
		for i, v in pairs(deep_clone(from_object))  do
			to_object[i] = v
		end
	end
end

function SerializableObject:copy_fields(serialize_class)
	self._fields = {}
	for i,v in pairs(serialize_class._fields) do
		self._fields[i] = v
		self._current_order = i
	end
end

function SerializableObject:register_field(field_name, value_type, classType)
	if not self._current_order then
		self._current_order = 0
	end

	if not self._fields then
		self._fields = {}
	end

	self._current_order = self._current_order + 1

	if self._fields[self._current_order] then
		print("order "..self._current_order.. " has a field already!!")
	end

	self._fields[self._current_order] = {}
	
	print("registering field " .. field_name ..  " current order " .. self._current_order)

	self._fields[self._current_order].Serialize_callback = function(writer, final)
		if final then
			writer:WriteFinal(field_name, value_type)
		else
			writer:Write(field_name, value_type)
		end
	end


	self._fields[self._current_order].load_callback = function(o,...)
		if value_type == "object" then
			o:apply_class(field_name, classType)
		elseif value_type == "array" then
			o:apply_class_to_array(field_name, classType)
		end
	end

	self._fields[self._current_order].new_callback = function(o,...)
		if value_type == "string" then
			o[field_name] = ""
		elseif value_type == "number" then
			o[field_name] = 0
		elseif value_type == "boolean" then
			o[field_name] = false
		elseif value_type == "object" then
			local class = rawget(_G, classType)
			if class then
				o[field_name] = class:new()
				print("Registering classType : " .. classType)
			else
				print("could not assign field to classType : " .. classType)
			end
		elseif value_type == "array" or value_type == "string_array" or value_type == "number_array" then
			o[field_name] = {}
		end
	end


end



function SerializableObject:load_additional(data)
	self:object_callback("load_callback",self, data)
end

function SerializableObject:load(data)
	local object = {}
	setmetatable(object, self)	
	copy_values_to_object(object, data)
	object:load_additional(data)
	return object
end


function SerializableObject:SerializeFields(writer)
	if self._current_order and self._current_order > 0 then
		for i = self._current_order, 1, -1 do
			self._fields[i].Serialize_callback(writer, i == 1)
		end
	end
end


function SerializableObject:Serialize(indent, ignore_first_indent)
	local writer = JsonWriter:new(self, indent)
	self:SerializeFields(writer)
	return writer:Results()
end
