dofile(ModPath.."Lua/Init.lua")
local update_trigger_area = GameSetup.update
function GameSetup:update(t, dt)	
	managers.cell_cooldown:update(t,dt)
	StateMachine.update_machines(t,dt)	
	CellSoundObject.update_soundObjects(t,dt)	
	managers.cell_user:update(t,dt)
	return update_trigger_area(self, t, dt)
end

local _GameSetup_init_managers = GameSetup.init_managers
function GameSetup:init_managers(managers, ...)
	_GameSetup_init_managers(self, managers, ...)
	managers.cell_data = CellDataBlockManager:new()
	managers.cell_network = CellNetworkManager:new()	
	managers.cell_input = InputManager:new()		
	managers.cell_voice = PlayerVoiceManager:new()		
	managers.cell_user = CellUserManager:new()
	managers.cell_options = CellOptionsManager:new()	
	managers.cell_drama = DramaManager:new()
	managers.cell_world = ChatterWorldManager:new()
	managers.cell_music = CellMusicManager:new()
	managers.cell_condition = PlayerConditionManager:new()
	managers.cell_callback = CallBackManager:new()	
	managers.cell_cooldown = CoolDownManager:new()	
	managers.cell_pager = CellPagerManager:new()	
	managers.cell_drill = DrillManager:new()	
	managers.cell_interaction = CellInteractionManager:new()	
	managers.cell_narrator = CellNarratorManager:new()	
end


local init_fin_orig = GameSetup.init_finalize
function GameSetup:init_finalize(...)
	init_fin_orig(self, ...)
	
	local levels_sounds = {
		"short1/stage1",
		"short1/stage2",
		"short2/stage1",
		"short2/stage2",
		"bain/rvd/stage1",
		"vlad/ukrainian_job",
	}
	for i, path_name in pairs(levels_sounds) do
		if not PackageManager:loaded( "levels/narratives/"..path_name.."/world_sounds" ) then
			PackageManager:load( "levels/narratives/"..path_name.."/world_sounds" )
			log("Loading World sound: levels/narratives/"..path_name.."/world_sounds")
		end
	end
	
	
	--DeadLocke.DeadLockeMissionManager = DeadLocke.MissionManager:new()
	--DeadLocke.DeadLockeMissionManager:parse()
end