DeadLockeNetwork = DeadLockeNetwork or blt_class()
DeadLockeNetwork._syncable_functions = {
	"sync_end_dialog",
	"sync_dialog_tag_cooldown",	
	"bain_comment",
	"sync_ban_info_dialog",
	"sync_criminal_comment",
	"sync_dialog_cooldown",
	"sync_last_speaker",
	"sync_music_event",
	"sync_str_indexes",
	"sync_deadlock_pended",
	"sync_deadlock_pended_from_start",
	"sync_music_ghost_ext",
	"sync_deadlock_pending",
	"sync_sound_playback",
	"sync_sound_playback_on_character",
	"request_to_start_dialog",
	"request_to_end_dialog",
	"sync_drama_state",
	"sync_stop_mod_cue",
	"sync_level_up_dialog",
	"set_story_order",
	"sync_change_state_to_peer"
}

DeadLockeNetwork._deadlocke_host_only = {
	"sync_dialog_cooldown",
	"sync_level_up_dialog",
	"set_story_order"
}









function DeadLockeNetwork:bain_comment(bain_line, skip_narr_prefix, sender)
	if not self:_verify_network_check()	then
		return
	end
	
	if managers.dialog and managers.groupai and managers.groupai:state():bain_state() then
		if skip_narr_prefix then
			managers.dialog:queue_dialog(bain_line, {})
		else
			managers.dialog:queue_narrator_dialog(bain_line, {})
		end
	end
end

function DeadLockeNetwork:sync_level_up_dialog(name, level, sender)
	if not self:_verify_network_check()	then
		return
	end
	
	if not DialogHandlerAssault.level_dialogs[name] then
		return
	end
	
	DialogHandlerAssault.level_dialogs[name] = level
end

function DeadLockeNetwork:sync_drama_state(drama_state, sender)
	if not self:_verify_network_check()	then
		return
	end
	
	managers.deadlocke_drama:sync_change_state_to_peer(sender, drama_state)	
end

function DeadLockeNetwork:run_deadlocke_mission_element(id, character, last_orientation_index, sender)
	if not self:_verify_network_check()	then
		return
	end
	
	local unit = managers.criminals:character_unit_by_name(character)
	if not unit or not alive(unit) then
		unit = nil
	end
	DeadLocke:on_execute_mod(id, unit)
end

function DeadLockeNetwork:run_deadlocke_mission_element_no_instigator(id, last_orientation_index, sender)
	if not self:_verify_network_check()	then
		return
	end
	
	DeadLocke:on_execute_mod(id, nil)
end


function DeadLockeNetwork:request_to_start_dialog(dialogId, actors_strings, force_quit_current, sender)
	if not self:_verify_network_check()	then
		return
	end
	
	managers.player_dialog:sync_start_dialog(dialogId, actors_strings, force_quit_current)
end

function DeadLockeNetwork:request_to_end_dialog(priority, sender)
	if not self:_verify_network_check()	then
		return
	end
	
	if not DeadLocke:incharge() then
		return
	end
	
	managers.player_dialog:stop_dialog(priority)	
end

function DeadLockeNetwork:sync_dialog_cooldown(id, timer, sender)
	if not self:_verify_network_check()	then
		return
	end
	
	managers.player_dialog:sync_cooldown(id, timer)	
end



function DeadLockeNetwork:set_story_order(StoryID, currentOrder, sender)
	if not self:_verify_network_check()	then
		return
	end
	
	local storyblock = managers.deadlockegameblock:wrapper("PlayerDialogStoryDataBlock"):get_block_by_id(StoryID)
	if storyblock and storyblock.persistentID > 0 then
		storyblock.currentOrder = currentOrder
	end
	
end



function DeadLockeNetwork:sync_stop_mod_cue(cue_name, sender)
	if not self:_verify_network_check()	then
		return
	end
	
	DeadLocke:stop_mod_cue(cue_name, false)
end




function DeadLockeNetwork:sync_sound_playback(sound_name, slot_strings, cue_name, sender)	
	if not self:_verify_network_check()	then
		return
	end
	
	local params = {
		slot_strings = slot_strings,
		cue_name = cue_name,
		sync = false
	}
	
	local playbck = DeadLocke:_get_sound_playback_from_id(sound_name)
	if playbck then
		params.type = "none"
		params.relative = true			
		DeadLocke:_play_plyback(playbck, params)			
	end
end

function DeadLockeNetwork:sync_sound_playback_on_character(sound_name, character, slot_strings, cue_name, sender)	
	if not self:_verify_network_check()	then
		return
	end
	
	
	local unit = managers.criminals:character_unit_by_name(character)
	if unit and alive(unit) then
		local params = {
			slot_strings = slot_strings,
			cue_name = cue_name,
			sync = false
		}
		unit:sound():say_mod(sound_name, params)
	end	
end


function DeadLockeNetwork:sync_ban_info_dialog(dialog_i, sync_required_values_str, sender)
	if not self:_verify_network_check()	then
		return
	end
	
	
	managers.groupai:state():sync_ban_info_dialog(dialog_i, sync_required_values_str)
end


function DeadLockeNetwork:sync_criminal_comment(trigger_unit_name, allow_first_person, message, string_pos, pos_based, radius, play_ogg_comment)
	if not self:_verify_network_check()	then
		return
	end
	
	
	DeadLocke:criminal_comment(trigger_unit_name, allow_first_person, message, string_pos, pos_based, radius, play_ogg_comment, false)
end

function DeadLockeNetwork:sync_last_speaker(character, sender)
	if not self:_verify_network_check()	then
		return
	end
	
	local unit = managers.criminals:character_unit_by_name(character)
	if unit then
		DeadLocke._last_speaker = unit
	end
	
end



function DeadLockeNetwork:sync_music_event(event, sender)
	if not self:_verify_network_check()	then
		return
	end
	
	managers.music:post_event(event)
end



function DeadLockeNetwork:sync_music_ghost_ext(music_ext, switch, sender)
	if not self:_verify_network_check()	then
		return
	end
	
	if music_ext ~= "none" then
		managers.music:post_event(music_ext)
	end
	
	managers.music:post_event(switch)
end




function DeadLockeNetwork:sync_change_criminal_voice(character, voice, sender)
	if not self:_verify_network_check()	then
		return
	end
	
	local criminal = managers.criminals:character_unit_by_name(character)
	if criminal and alive(criminal) then
		criminal:sound():set_voice(voice)
	end
end

function DeadLockeNetwork:test_russian_say(sender)
	if not self:_verify_network_check()	then
		return
	end
	
	local unit = managers.criminals:character_unit_by_name("russian")
	if unit and alive(unit) then
		unit:sound():say("g29")
	end
end


function DeadLockeNetwork:sync_str_indexes(str_indexes, sender) 
	if not self:_verify_network_check()	then
		return
	end
	
	
	local user = DeadLocke:get_user(sender)
	if user then
		user:apply_dlocke_options_to_peer(str_indexes)
	end	
end




function DeadLockeNetwork:sync_deadlock_pended(str_indexes, from_start, sender) 
	local user = DeadLocke:add_peer(sender)	
	if user then
		user:apply_dlocke_options_to_peer(str_indexes)
		if from_start then
			user:start_from_beginning()
		end
	end	
end




function DeadLockeNetwork:sync_deadlock_pending(str_indexes, sender)
	local user = DeadLocke:add_peer(sender)
	if user then
		user:apply_dlocke_options_to_peer(str_indexes)
		user:send_deadlocke_response()		
	end	
end







