PlayerMaskOff.voice_type_varies = PlayerStandard.voice_type_varies
PlayerMaskOff.get_voice_type_varies = PlayerStandard.get_voice_type_varies

function PlayerMaskOff:mark_units(line, t, no_gesture, skip_alert)
	local mark_sec_camera = managers.player:has_category_upgrade("player", "sec_camera_highlight_mask_off")
	local mark_special_enemies = managers.player:has_category_upgrade("player", "special_enemy_highlight_mask_off")
	local voice_type, plural, prime_target = self:_get_unit_intimidation_action(mark_special_enemies, false, false, false, false)
	local interact_type, sound_name = nil

	if voice_type == "mark_cop" or voice_type == "mark_cop_quiet" then
		interact_type = "cmd_point"
		local _tweak_table = tweak_data.character[prime_target.unit:base()._tweak_table]
		if _tweak_table then
			local _priority_shout = voice_type == "mark_cop_quiet" and "silent_priority_shout" or "priority_shout"
			if _tweak_table[_priority_shout] then
				shout_sound = _tweak_table[_priority_shout]..(voice_type == "mark_cop_quiet" and "_any" or "x_any")
				if voice_type == "mark_cop_quiet" then
					sound_name = managers.deadlocke_interaction:modify_value("PlayerStandard:_start_action_intimidate", shout_sound, "mark_cop_quiet")
				else
					sound_name = managers.deadlocke_interaction:modify_value("PlayerStandard:_start_action_intimidate", shout_sound, "mark_"..prime_target.unit:base()._tweak_table, prime_target.unit)
				end
			end
		end
		if managers.player:has_category_upgrade("player", "special_enemy_highlight") then
			prime_target.unit:contour():add(managers.player:get_contour_for_marked_enemy(), true, managers.player:upgrade_value("player", "mark_enemy_time_multiplier", 1))
		end
	elseif voice_type == "mark_camera" and mark_sec_camera then
		sound_name = managers.deadlocke_interaction:modify_value("PlayerStandard:_start_action_intimidate", "f39_any", "mark_camera")
		interact_type = "cmd_point"

		prime_target.unit:contour():add("mark_unit", true)
	end

	if interact_type then
		self:_do_action_intimidate(t, not no_gesture and interact_type or nil, sound_name, skip_alert)

		return true
	end

	return mark_sec_camera or mark_special_enemies
end