PlayerSound.THIRD_PERSON_STRINGS = {
	"g90",
	"g50",
	"s09a",
	"s09b",
	"s09c",
	"s05a_sin",
	"s05b_sin"
}

PlayerSound.THIRD_PERSON_IDS = {}
for i,v in pairs(PlayerSound.THIRD_PERSON_STRINGS) do
	PlayerSound.THIRD_PERSON_IDS[v] = SoundDevice:string_to_id(v)
end

function PlayerSound.is_third_person_sound(sound_name)
	if sound_name and type(sound_name) == "number" then
		return table.contains(PlayerSound.THIRD_PERSON_IDS, sound_name) and true or false
	end	
	return table.contains(PlayerSound.THIRD_PERSON_STRINGS, sound_name) and true or false
end


local _PlayerSound_say = PlayerSound.say
function PlayerSound:say(sound_name, ...)
	if self._unit:base().is_local_player then 
		self._unit:sound_source():set_switch("int_ext", PlayerSound.is_third_person_sound(sound_name) and "third" or "first")
	end	
	
	self._last_speech = _PlayerSound_say(self, sound_name, ...)
	
	if self._unit.base and self._unit:base() and self._unit:base().is_local_player then
		self._unit:sound_source():set_switch("int_ext", "third")
	end

	return self._last_speech
end

